_debug("Setting up settings.");

function setAllDisabled(disabled) {
  var i;
  for (i = 0; i < prefs.length; ++i) {
    document.getElementById(prefs[i].containerId).disabled = disabled;
  }
}

function setupBoolPref(pref) {
  // Uh...name or id?
  var group = document.getElementById(pref.containerId);
  if (!group) {
    alert("Couldn't find " + pref.containerId);
    return;
  }
  var id = getPrefs().getBoolPref(pref.prefName);
  var elt;
  if (id) {
    elt = document.getElementById(pref.trueId);
  }
  if (!elt || !id) {
    elt = document.getElementById(pref.falseId);
  }
  if (!elt) { // bad pref?
    alert("Failed to find " + pref.trueId + " or " + pref.falseId);
    elt = document.getElementById(pref.trueId);
  }
  if (elt) {
    group.selectedItem = elt;
  }
}

function saveBoolPref(pref) {
  var elt = document.getElementById(pref.trueId);
  var old = getPrefs().getBoolPref(pref.prefName);
  getPrefs().setBoolPref(pref.prefName, elt.selected);
}

function saveEnableFlag() {
  var elt = document.getElementById("jv-settings-checkbox");
  if (!elt) {
    alert("Couldn't find checkbox!");
    return;
  }
  var enabled = getEnabledPref();
  if (elt.checked != enabled) {
    enabled = elt.checked;
    saveEnabledPref(enabled);
  }
  return enabled;
}

function jv_checkSettings() {
  var i;
  try {
    for (i = 0; i < prefs.length; ++i) {
      setupBoolPref(prefs[i]);
    }
    // set 'enabled' checkbox
    var elt = document.getElementById("jv-settings-checkbox");
    if (!elt) {
      alert("missing elt!");
    }
    var enabled = getEnabledPref();
    if (elt) {
      elt.checked = enabled;
    }
    setAllDisabled(!enabled);
  } catch (ex) {
    dump(stringifyObj(ex));
  }
}

function jv_EnabledToggled() {
  var elt = document.getElementById("jv-settings-checkbox");
  if (!elt) {
    alert("Couldn't find checkbox!");
    return;
  }
  setAllDisabled(!elt.checked);
}

function jv_saveSettings() {
  // Radio buttons first
  var i;
  for (i = 0; i < prefs.length; ++i) {
    saveBoolPref(prefs[i]);
  }

  // Now the global enable flag
  var enabled = saveEnableFlag();

  // Now tell everybody
  notifyAll(enabled);
}

window.addEventListener("load", jv_checkSettings, true);

function jv_settingsKeypress(evt) {
  if (evt.keyCode == evt.DOM_VK_ESCAPE)
    window.close();
}

window.addEventListener("keypress", jv_settingsKeypress, true);

_debug("Set up settings.");
