function JvBoolPref(containerId, trueSuffix, falseSuffix, prefName, varName,
    onUpdate) {
  this.containerId = "jv-settings-" + containerId;
  this.trueId = this.containerId + trueSuffix;
  this.falseId = this.containerId + falseSuffix;
  this.prefName = prefName;
  this.varName = varName;
  this.onUpdate = onUpdate;
  return this;
}

var prefs = [
  new JvBoolPref(
      "tab-handling",
      "-ignore", "-insert",
      "tab.handling.ignore",
      "neverHandleTab",
      null),
  new JvBoolPref(
      "default-mode",
      "-insert", "-normal",
      "default.mode.insert",
      "defaultModeInsert",
      null),
  new JvBoolPref(
      "undo-mode",
      "-vi", "-vim",
      "undo.mode.vi",
      "undoModeVi",
      null),
  new JvBoolPref(
      "visual-bell",
      "-inhibit", "-allow",
      "visual.bell.inhibit",
      "inhibitVisualBell",
      null),
  new JvBoolPref(
      "status-bar",
      "-show", "-hide",
      "status.bar.show",
      "showStatusBar",
      function (jsvim) {
        if (jsvim.showStatusBar) {
          jsvim.setUpStatusBar();
        } else {
          jsvim.removeStatusBar();
        }
      }),
  new JvBoolPref(
      "debugging-asserts",
      "-popup", "-ignore",
      "debugging.asserts.popup",
      "popupOnAssert",
      null),
];

function getPrefs() {
  var prefsvc = Components.classes["@mozilla.org/preferences-service;1"].
    getService(Components.interfaces.nsIPrefService);

  return prefsvc.getBranch("extensions.jv.");
}

function getEnabledPref() {
  return getPrefs().getBoolPref("enabled");
}

function saveEnabledPref(enabled) {
  getPrefs().setBoolPref("enabled", enabled);
}

function isEnabled() {
  // If this isn't fast, we can cache it in this.genabled or something.
  if(!getEnabledPref()) {
    return false;
  }
  return this.lenabled;
}

function updateEditorPrefs() {
  var i;
  if (!this.e) {
    // disabled
    return;
  }
  if (!this.updateEpoch) {
    this.updateEpoch = 1;
  }
  if (this.updateEpoch != this.getVar(this.VarNames.UPDATE_EPOCH)) {
    for (i = 0; i < prefs.length; ++i) {
      var pref = prefs[i];
      this[prefs[i].varName] = getPrefs().getBoolPref(prefs[i].prefName);
      if (prefs[i].onUpdate) {
        prefs[i].onUpdate(this);
      }
    }
    this.setVar(this.VarNames.UPDATE_EPOCH, this.updateEpoch);
  }
}

function notifyAll(enabled) {
  try {
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
      .getService(Components.interfaces.nsIWindowMediator);
    var enumerator = wm.getEnumerator("navigator:browser");
    if (enumerator) {
      while (enumerator.hasMoreElements()) {
        var w = enumerator.getNext();
        if (w && w.jsvim) {
          var epoch = w.jsvim.updateEpoch;
          if (!epoch) {
            epoch = 1;
          }
          w.jsvim.updateEpoch = epoch + 1;
          w.jsvim.updatePopup();
          w.jsvim.updateIcon();
          w.jsvim.updateEditorPrefs();
          if (!enabled) {
            w.removeEventListener("focus", w.jsvim, true);
            w.removeEventListener("keypress", w.jsvim, true);
            w.removeEventListener("click", w.jsvim, true);
          } else {
            w.addEventListener("focus", w.jsvim, true);
            w.addEventListener("keypress", w.jsvim, true);
            w.addEventListener("click", w.jsvim, true);
          }
        }
      }
    }
  } catch (ex) {
    // TODO: Should this be a popup?  Make popups a debugging preference?
    _debug(stringifyObj(ex));
  }
}
