function debug(s) {
  dump(s + '\n');
}

var _debug = debug;

function stringifyObj(obj) {
  if (!obj) {
    return "null object";
  }
  var str = "";
  for (var i in obj) {
    str += i + ":\t";
    try {
      str += obj[i] + '\n';
    } catch (ex) {
      str += typeof obj;
    }
  }
  return str;
}

function popup(s) {
  var str = s + "\n" + stringifyObj(new Error());
  _debug(str);
  if (!jsvim || jsvim.popupOnAssert) {
    alert(str);
  }
}

function stringifyObjNames(obj) {
  if (!obj) {
    return "null object";
  }
  var tag;
  if (obj.name) {
    tag = "(Name) " + obj.name;
  } else if (obj.title) {
    tag = "(Title) " + obj.title;
  } else if (obj.id) {
    tag = "(ID) " + obj.id;
  } else {
    tag = "(OBJECT)";
  }
  var str = tag + ": ";

  for (i in obj) {
    str += i + ", ";
  }
  return str;
}

// Usage example: eval(getDebugEvalString("element.offsetWidth"));
// See debugByName().
function getDebugEvalString(name) {
  return "_debug(\"" + name + " is \" + " + name + ");";
}

function debugByName(name) {
  eval(getDebugEvalString(name));
}

function assert(t) {
  if (!t) {
    popup(stringifyObj(new Error("Assertion failed!")));
    throw "Assertion failed!";
  }
}

var timingEvents;

function initTiming() {
 timingEvents = new Array();
}

function pushTimingEvent(text) {
  if (timingEvents) {
    timingEvents.push([text, new Date().getTime()]);
  }
}

function dumpTimingEvents() {
  if (timingEvents) {
    var lastTime = 0;
    timingEvents.reverse();
    _debug("");
    while (timingEvents.length) {
      var record = timingEvents.pop();
      var text = record[0];
      var time = record[1];
      _debug(text + ",\t" + time + ",\t" + (time - lastTime));
      lastTime = time;
    }
    _debug("");
  } else {
    initTiming();
  }
}

